(****
autor/author.....:	mariano d. podesta - marianopodesta@usa.net
empresa/firm.....:
fecha/date.......:	04/1999
contiene/contents:	basic POP3 demo
notas/notes......:  this demo works on delphi 3 (or newer) and use delphi sockets
****)
unit basic;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	wlpop3, StdCtrls, ScktComp, ComCtrls;

type
  TfBasic = class(TForm)
    popClient: TWirelessPOP3;
    Label5: TLabel;
		laStatus: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edHost: TEdit;
    Label2: TLabel;
    edPort: TEdit;
    Label3: TLabel;
    edUser: TEdit;
    Label4: TLabel;
    edPassword: TEdit;
    btLogout: TButton;
    GroupBox2: TGroupBox;
    btStat: TButton;
    Label6: TLabel;
    laCount: TLabel;
    Label7: TLabel;
    laSize: TLabel;
    csSock: TClientSocket;
		GroupBox3: TGroupBox;
    Label8: TLabel;
    lbAttachments: TListBox;
		GroupBox4: TGroupBox;
    Label10: TLabel;
    cbNumber: TComboBox;
    memText: TMemo;
    btAttachmentSave: TButton;
    btClose: TButton;
    sdSaveAs: TSaveDialog;
    btOpen: TButton;
    pbPerc: TProgressBar;
    laPerc: TLabel;
    btDelete: TButton;
    procedure csSockConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure csSockConnecting(Sender: TObject; Socket: TCustomWinSocket);
    procedure csSockDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure csSockError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure csSockRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure popClientWriteData(Sender: TObject; Buffer: PChar;
      const Count: Integer);
    procedure popClientError(Sender: TObject; const Error: TPop3ErrorKind);
    procedure popClientHostGreetings(Sender: TObject);
    procedure popClientLogin(Sender: TObject);
    procedure popClientLogout(Sender: TObject);
    procedure popClientMailDropInfo(Sender: TObject);
		procedure popClientRetrieveHeader(Sender: TObject);
    procedure popClientRetrieveMessage(Sender: TObject);
    procedure btLogoutClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btAttachmentSaveClick(Sender: TObject);
    procedure btStatClick(Sender: TObject);
		procedure cbNumberClick(Sender: TObject);
		procedure btOpenClick(Sender: TObject);
    procedure popClientProgress(Sender: TObject; const Kind: TProgressKind;
      const Percent: Integer);
    procedure btDeleteClick(Sender: TObject);
    procedure popClientDeleteMessage(Sender: TObject);
	private
		FCurrent: TMailMessage;
		FClose: Boolean;
	end;

var
  fBasic: TfBasic;

implementation

{$R *.DFM}

procedure TfBasic.csSockConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
	laStatus.Caption := 'Connected';
end;

procedure TfBasic.csSockConnecting(Sender: TObject; Socket: TCustomWinSocket);
begin
	laStatus.Caption := 'Searching host...';
end;

procedure TfBasic.csSockDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
	laStatus.Caption := 'Disconnected';
end;

procedure TfBasic.csSockError(Sender: TObject; Socket: TCustomWinSocket;
	ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
	laStatus.Caption := 'Communication error';
	ErrorCode := 0;
end;

procedure TfBasic.csSockRead(Sender: TObject; Socket: TCustomWinSocket);
var
	sBuffer: String;
begin
	SetLength(sBuffer, Socket.ReceiveLength);
	Socket.ReceiveBuf(sBuffer[1], Length(sBuffer));
	popClient.ReadData(PChar(sBuffer), Length(sBuffer));
end;

procedure TfBasic.popClientWriteData(Sender: TObject; Buffer: PChar;
	const Count: Integer);
begin
	csSock.Socket.SendBuf(Buffer^, Count);
end;

procedure TfBasic.popClientError(Sender: TObject;
	const Error: TPop3ErrorKind);
begin
	case Error of
		ekUserName: 				laStatus.Caption := 'POP Error: UserName';
		ekPassword:					laStatus.Caption := 'POP Error: Password';
		ekRetrieveHeader:		laStatus.Caption := 'POP Error: RetrieveHeader';
		ekRetrieveMessage:	laStatus.Caption := 'POP Error: RetrieveMessage';
		ekRetrieveUIDL:			laStatus.Caption := 'POP Error: RetrieveUIDL';
		ekDeleteMessage:		laStatus.Caption := 'POP Error: DeleteMessage';
		ekQuit:							laStatus.Caption := 'POP Error: Quit';
		ekMailDropInfo:			laStatus.Caption := 'POP Error: MailDropInfo';
		ekMessageList:			laStatus.Caption := 'POP Error: MessageList';
	end;
end;

procedure TfBasic.popClientHostGreetings(Sender: TObject);
begin
	laStatus.Caption := 'Host ready';

	cbNumber.Clear;
	memText.Clear;
	lbAttachments.Clear;

	popClient.UserName := edUser.Text;
	popClient.Password := edPassword.Text;
	popClient.Login;
end;

procedure TfBasic.popClientLogin(Sender: TObject);
begin
	laStatus.Caption := 'Login successful';
	btLogout.Enabled := true;
	btStat.Enabled := true;
end;

procedure TfBasic.popClientLogout(Sender: TObject);
begin
	laStatus.Caption := 'Logout successful';
	btLogout.Enabled := false;
	btStat.Enabled := false;

	if csSock.Active then csSock.Close;
	if FClose then Close;
end;

procedure TfBasic.popClientMailDropInfo(Sender: TObject);
var
	i: Integer;
begin
	laStatus.Caption := 'Received maildrop info';
	laCount.Caption := IntToStr(popClient.MessageCount);
	laSize.Caption := IntToStr(popClient.TotalSize);

	cbNumber.Clear;

	for i := 1 to popClient.MessageCount do
		cbNumber.Items.Add(IntToStr(i));
end;

procedure TfBasic.popClientRetrieveHeader(Sender: TObject);
begin
	laStatus.Caption := 'Header retrieved (waitting for message body)';
	if Sender <> nil then FCurrent := popClient.CurrentMessage;

	memText.Clear;
	lbAttachments.Clear;
	memText.Lines.Add('From: ' + FCurrent.GetLabel('From'));
	memText.Lines.Add('To: ' + FCurrent.GetLabel('To'));
	memText.Lines.Add('Subject: ' + FCurrent.GetLabel('Subject'));
	memText.Lines.Add('Date: ' + FCurrent.GetLabel('Date'));
	memText.Lines.Add('');
end;

procedure TfBasic.popClientRetrieveMessage(Sender: TObject);
begin
	laStatus.Caption := 'Message retrieved';

	memText.Lines.Add(FCurrent.GetMainText);
	FCurrent.GetAttachedList(lbAttachments.Items);
	btAttachmentSave.Enabled := lbAttachments.Items.Count > 0;
end;

procedure TfBasic.btOpenClick(Sender: TObject);
begin
	if edHost.GetTextLen = 0 then Exit;

	if edHost.Text[1] in ['0'..'9'] then
	begin
		csSock.Address := edHost.Text; // search address (ej: 220.21.210.10)
		csSock.Host := '';
	end else
	begin
		csSock.Address := '';
		csSock.Host := edHost.Text;		// search host name (ej: mail.popserver.com)
	end;

	csSock.Port := StrToInt(edPort.Text);
	csSock.Open;
end;

procedure TfBasic.btLogoutClick(Sender: TObject);
begin
	popClient.Logout;
end;

procedure TfBasic.btAttachmentSaveClick(Sender: TObject);
var
	sFile: String;
begin
	if lbAttachments.ItemIndex < 0 then Exit;

	sFile := lbAttachments.Items.Strings[lbAttachments.ItemIndex];
	sdSaveAs.FileName := sFile;

	if sdSaveAs.Execute then
		FCurrent.SaveAttachedToFile(sFile, sdSaveAs.FileName);
end;

procedure TfBasic.btStatClick(Sender: TObject);
begin
	popClient.RetrieveMailDropInfo;
end;

procedure TfBasic.cbNumberClick(Sender: TObject);
var
	iMessage: Integer;
begin
	iMessage := StrToIntDef(cbNumber.Text, 0);
	if iMessage = 0 then Exit;

	FCurrent := popClient.MessageByNumber(iMessage);

	if FCurrent = nil then
	begin
		laStatus.Caption := 'Retrieving message #' + IntToStr(iMessage);
		popClient.RetrieveMessage(iMessage);
	end else
	begin
		popClient.OnRetrieveHeader(nil);
		popClient.OnRetrieveMessage(nil);
	end;
end;

procedure TfBasic.btCloseClick(Sender: TObject);
begin
	FClose := true;

	if popClient.IsLogged then
		popClient.Logout else
		Close;
end;

procedure TfBasic.popClientProgress(Sender: TObject;
	const Kind: TProgressKind; const Percent: Integer);
begin
	pbPerc.Position := Percent;
	laPerc.Caption := IntToStr(Percent) + '%';
	laPerc.Update; // better than Application.ProcessMessages;
end;

procedure TfBasic.btDeleteClick(Sender: TObject);
var
	iMessage: Integer;
begin
	iMessage := StrToIntDef(cbNumber.Text, 0);
	if iMessage > 0 then popClient.DeleteMessage(iMessage);
end;

procedure TfBasic.popClientDeleteMessage(Sender: TObject);
var
	iMessage: Integer;
begin
	iMessage := StrToIntDef(cbNumber.Text, -1);
	laStatus.Caption := 'Message #' + IntToStr(iMessage) + ' deleted';
end;

end.
